<template>
  <div class="account-order-wrapper">
    <div
      v-show="loader"
      class="account-order-loader"
    >
      <ob-loader
        :width="10"
        :height="10"
        :duration="2"
      />
    </div>
    <div v-if="isExistOrderInList" :class="[order.uuid ? 'account-order' : 'account-order__no-order']">
      <div class="height-100" v-if="order.uuid">
        <div class="account-order__detail height-100">
          <template v-if="isOffer">
            <OfferHeader />
          </template>
          <template v-else>
            <div class="account-order__detail--top">
              <price-block ref="price" />
              <!--<voyage :isType="order.type"/>-->
              <advances v-if="hasAdvance"/>
            </div>
          </template>
          <div :style="{height: detailHeight}" class="account-order__detail--other">
            <!-- <person/>-->
            <confirm/>
            <subscribe-resource v-if="hasSubscribe"/>
            <sign v-if="hasSign" />
          </div>
        </div>
      </div>
      <div v-else>
        Запрос не выбран
      </div>
    </div>
  </div>
</template>
<script>
  import ObLoader from "common-components/src/obComponents/obLoader";
  import priceBlock from './steps/top/price'
  //import voyage from './steps/top/voyage/index'
  import advances from './components/advances'
  import subscribeResource from './steps/bottom/subscribeResource'
  import sign from './steps/bottom/sign'
  import STEPS from '@/constants/steps.js'
  import { mapGetters, mapActions } from 'vuex'
  //import person from './components/person';
  import confirm from './steps/bottom/confirm'
  import OfferHeader from './components/offerHeader'

  export default {
    components: {
      ObLoader,
      priceBlock,
      //person,
      subscribeResource,
      sign,
      //voyage,
      advances,
      confirm,
      OfferHeader
    },
    data () {
      return {
        STEP: STEPS,
        detailHeight: 0,
        updateInterval: null
      }
    },
    computed: {
      ...mapGetters({
        order: 'account/order',
        loader: 'account/rightPanel',
        currentOrdersList: 'account/currentOrdersList',
        contractorUuid: 'user/participantUuid',
        isAuction: 'account/isAuction',
        isBooking: 'account/isBooking',
        isOffer: 'account/isOffer',
      }),
      isExistOrderInList () {
        return this.currentOrdersList.find(item => item.uuid === this.order?.uuid)
      },
      isMainOrder () {
        return this.contractorUuid === this.order?.contractorUuid
      },
      hasAdvance () {
        if (this.order.status === this.STEP.WINNER) {
          return this.order.orderStatus === this.STEP.ALLOCATED ||
              this.order.orderStatus === this.STEP.CONTRACTED;
        } else {
          return false;
        }
      },
      hasSubscribe () {
        if (this.order.status === this.STEP.WINNER && this.isMainOrder || this.order.carrierSearchType === this.STEP.OFFER) {
          return this.order.orderStatus === this.STEP.BOOKED ||
              this.order.orderStatus === this.STEP.ALLOCATED ||
              this.order.orderStatus === this.STEP.CONTRACTED ||
              (this.order.resources?.length && this.order.carrierSearchType === this.STEP.OFFER)
        } else {
          return false;
        }
      },
      hasSign () {
        if (this.order.status === this.STEP.WINNER && this.isMainOrder || this.order.carrierSearchType === this.STEP.OFFER) {
          return this.order.orderStatus === this.STEP.ALLOCATED ||
              this.order.orderStatus === this.STEP.CONTRACTED
        } else {
          return false;
        }
      }
    },
    methods: {
      ...mapActions({
        getOrder: 'account/getOrder'
      }),
      setUpdateInterval () {
        clearInterval(this.updateInterval)
        this.updateInterval = setInterval(() => {
          if (this.order?.uuid && this.isExistOrderInList && !this.loader) {
            this.getOrder(this.order)
          }
        }, 10000)
      }
    },
    watch: {
      order (order) {
        if (order?.uuid) {
          this.setUpdateInterval()
        }
      }
    },
    mounted() {
      this.detailHeight = window.innerHeight - 410 + 'px';
    },
    beforeDestroy() {
      clearInterval(this.updateInterval)
    }
  };
</script>

<style lang="scss">
  @import "~common-components/src/static/css/variables";

  @mixin box-shadow-line() {
    position: relative;
    &::after {
      content: '';
      position: absolute;
      bottom: -4px;
      left: -20px;
      width: calc(100% + 40px);
      height: 4px;
      background: linear-gradient(180deg, rgba(196, 213, 237, 0.5) 0%, rgba(207, 222, 244, 0) 100%);
      opacity: 0.5;
    }
  }

  .account-order {
    height: 100%;
    &-wrapper{
      position: relative;
      width: 100%;
      height: 100%;
    }
    &-loader {
      position: absolute;
      z-index: 1000;
      height: 100%;
      width: 100%;
      display: flex;
      justify-content: center;
      align-items: center;
      top: 0;
      left: 0;
      background-color: rgba(255, 255, 255, 0.8);
    }
    &__title {
      font-weight: bold;
      font-size: 16px;
      line-height: 24px;
      letter-spacing: 0.4px;
      color: $color-text-base;
    }
    &__detail{
      display: flex;
      flex-direction: column;
      &--top{
        position: relative;
        @include box-shadow-line;
      }
      &--other{
        margin-top: 0;
        overflow-x: hidden;
        overflow-y: scroll;
        padding-right: 10px;
        position: relative;
        &::-webkit-scrollbar {
          width: 6px;
          background: transparent;
          opacity: .3;
        }
        &::-webkit-scrollbar-thumb {
          background: #b3d4e4;
          border-radius: 3px;
        }
        &::-webkit-scrollbar-track {
          background: transparent;
        }
      }
    }
    &__no-order {
      display: flex;
      text-align: center;
      flex-direction: column;
      justify-content: center;
      align-self: center;
      height: 100%;
      font-size: 24px;
      line-height: 29px;
      letter-spacing: 0.4px;
      color: $color-grey-span;
    }
    .height-100{
      height: 100%;
    }
  }
</style>
